Unit AFT1C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAFSI_p;

procedure AFT1C(var A :Array of Complex; M :Integer; N :Integer;
                LOW :Integer; var RCOND :Real;
                var Z :Array of Complex; var IERR :Integer);

implementation

procedure AFT1C(var A :Array of Complex; M :Integer; N :Integer;
                LOW :Integer; var RCOND :Real;
                var Z :Array of Complex; var IERR :Integer);
var
I,I0,I1,J,J0,J1,JJ,K,KB,LL,LM :Integer;
ANORM,S,SM,X,YNORM :Real;
EK,T,WK,WKM :Complex;
LOWER :Boolean;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320,_330,_340,_350,_360,_370,_380,_390,_400,_410;
{  -  FORTRAN }
function C1ABS(T: Complex): Real;
begin
Result := Abs(Creal(T)) + Abs(Aimag(T));
end;
{   - }
begin
{ *********************************************************C }
{    OEHKA CA OYCOBEHHOCT TPEYOHO MATP A.   C }
{ *********************************************************C }
RCOND := 0.0;

{   YCTAHOBEHE KOHTPO HA BOMOHOCT EPEOHEH }
X := 0.0;
_10:

{   POBEPKA PABHOCT AAH APAMETPOB M  N }
if ( N >=  1 ) and (  M >=  1 ) 
 then goto _20;
IERR := 65;
UTAFSI('A','F','T','1','C',IERR);
goto _410;
_20:
IERR := 0;
LOWER := ( LOW <>  0 );

{   BCEHE 1-HOPM MATP A }
ANORM := 0.0;
for J:=1 to N do
 begin
  S := 0.0;
  I0 := 1;
  if ( LOWER ) 
   then I0 := J;
  LM := J;
  if ( LOWER ) 
   then LM := N + 1 - J;
  I1 := I0 + LM - 1;
  I := ((LM) Mod (6)) + I0 - 1;
  if ( I <  I0 )
   then goto _40;
  for JJ:=I0 to I do
   begin
    S := S + C1ABS(A[(JJ-1)+(J-1)*M]);
_30:
   end;
_40:
  I := I + 1;
  if ( I >  I1 ) 
   then goto _60;
  JJ := I;
  while ( JJ<=I1 ) do
   begin
    S := S + C1ABS(A[(JJ-1)+(J-1)*M]) + C1ABS(A[(JJ+0)+(J-1)*M]) +
    C1ABS(A[(JJ+1)+(J-1)*M]) + C1ABS(A[(JJ+2)+(J-1)*M]) +
    C1ABS(A[(JJ+3)+(J-1)*M]) + C1ABS(A[(JJ+4)+(J-1)*M]);
_50:
    inc(JJ,6);
   end;
_60:
  if ( S >  ANORM )
   then ANORM := S;
  if ( Cabs(A[(J-1)+(J-1)*M]) =  0.0 ) 
   then IERR := -J;
_70:
 end;
if ( IERR =  0 ) 
 then goto _80;
UTAFSI('A','F','T','1','C',IERR);
goto _410;
_80:

{   BCEHE RCOND-BEH,OPATHO CY OYCOBEHHOCT MATP A. }
{    BCEH HOPM MATP INVERSE(A) PEAETC CCTEMA A*Z=Y, }
{   E Y-PEEHE CCTEM TRANS(A)*Y=E;KOMOHEHT BEKTOPA E BPATC }
{   TAKM OPAOM,TO MAKCMPOBAT HOPMY BEKTOPA Y }

{   PEEHE CCTEM TRANS(A)*Y=E OHOBPEMEHHO C BOPOM E }
EK := Cmplx(1.0,0.0);
if ( N >=  2 ) 
 then goto _90;
RCOND := 1.0;
goto _410;
_90:
for J:=1 to N do
 begin
  Z[J-1] := Cmplx(0.0,0.0);
_100:
 end;
for KB:=1 to N do
 begin
  K := KB;
  if ( LOWER ) 
   then K := N + 1 - KB;
  YNORM := C1ABS(EK);
  if ( C1ABS(Z[K-1]) <>  0.0 )
   then EK := MulC(SubC(Cmplx(0.0,0.0),Z[K-1]),Cmplx(YNORM/C1ABS(Z[K-1]),0.0));
  if ( C1ABS(SubC(EK,Z[K-1])) <=  C1ABS(A[(K-1)+(K-1)*M]) )
   then goto _170;
  S := C1ABS(A[(K-1)+(K-1)*M])/C1ABS(SubC(EK,Z[K-1]));
  LL := 160;
_110:
  I := ((N) Mod (5));
  T := Cmplx(S,0.0);
  if ( I =  0 ) 
   then goto _130;
  for JJ:=1 to I do
   begin
    Z[JJ-1] := MulC(T,Z[JJ-1]);
_120:
   end;
  if ( N <  5 ) 
   then goto _150;
_130:
  I := I + 1;
  JJ := I;
  while ( JJ<=N ) do
   begin
    Z[JJ-1] := MulC(T,Z[JJ-1]);
    Z[JJ+0] := MulC(T,Z[JJ+0]);
    Z[JJ+1] := MulC(T,Z[JJ+1]);
    Z[JJ+2] := MulC(T,Z[JJ+2]);
    Z[JJ+3] := MulC(T,Z[JJ+3]);
_140:
    inc(JJ,5);
   end;
_150:
  if ( LL=160 ) then goto _160 else
  if ( LL=310 ) then goto _310 else
  if ( LL=320 ) then goto _320 else
  if ( LL=400 ) then goto _400;
_160:
  EK := MulC(T,EK);
_170:
  WK := SubC(EK,Z[K-1]);
  WKM := SubC(SubC(Cmplx(0.0,0.0),EK),Z[K-1]);
  S := C1ABS(WK);
  SM := C1ABS(WKM);
  if ( Cabs(A[(K-1)+(K-1)*M]) =  0.0 ) 
   then goto _180;
  WK := DivC(WK,A[(K-1)+(K-1)*M]);
  WKM := DivC(WKM,A[(K-1)+(K-1)*M]);
  goto _190;
_180:
  WK := Cmplx(1.0,0.0);
  WKM := Cmplx(1.0,0.0);
_190:
  if ( KB >=  N ) 
   then goto _230;
  J0 := K + 1;
  if ( LOWER ) 
   then J0 := 1;
  J1 := N;
  if ( LOWER ) 
   then J1 := K - 1;
  for J:=J0 to J1 do
   begin
    SM := SM + C1ABS(AddC(Z[J-1],MulC(WKM,Conjg(A[(K-1)+(J-1)*M]))));
    Z[J-1] := AddC(Z[J-1],MulC(WK,Conjg(A[(K-1)+(J-1)*M])));
    S := S + C1ABS(Z[J-1]);
_200:
   end;
  if ( S >=  SM ) 
   then goto _220;
  T := SubC(WKM,WK);
  WK := WKM;
  for J:=J0 to J1 do
   begin
    Z[J-1] := AddC(Z[J-1],MulC(T,Conjg(A[(K-1)+(J-1)*M])));
_210:
   end;
_220:
_230:
  Z[K-1] := WK;
_240:
 end;
LL := 300;
_250:
S := 0.0;
I := ((N) Mod (6));
if ( I =  0 ) 
 then goto _270;
for JJ:=1 to I do
 begin
  S := S + C1ABS(Z[JJ-1]);
_260:
 end;
if ( N <  6 ) 
 then goto _290;
_270:
I := I + 1;
JJ := I;
while ( JJ<=N ) do
 begin
  S := S + C1ABS(Z[JJ-1]) + C1ABS(Z[JJ+0]) + C1ABS(Z[JJ+1])
    + C1ABS(Z[JJ+2]) + C1ABS(Z[JJ+3]) + C1ABS(Z[JJ+4]);
_280:
  inc(JJ,6);
 end;
_290:
S := 1.0/S;
if ( LL=300 ) then goto _300 else
if ( LL=390 ) then goto _390;
_300:
LL := 310;
goto _110;
_310:
YNORM := 1.0;

{   PEEHE CCTEM A*Z=Y }
for KB:=1 to N do
 begin
  K := N + 1 - KB;
  if ( LOWER ) 
   then K := KB;
  if ( C1ABS(Z[K-1]) <=  C1ABS(A[(K-1)+(K-1)*M]) ) 
   then goto _330;
  S := C1ABS(A[(K-1)+(K-1)*M])/C1ABS(Z[K-1]);
  LL := 320;
  goto _110;
_320:
  YNORM := S*YNORM;
_330:
  if ( Cabs(A[(K-1)+(K-1)*M]) <>  0.0 ) 
   then Z[K-1] := DivC(Z[K-1],A[(K-1)+(K-1)*M]);
  if ( Cabs(A[(K-1)+(K-1)*M]) =  0.0 ) 
   then Z[K-1] := Cmplx(1.0,0.0);
  if ( KB >=  N ) 
   then goto _370;
  I0 := 1;
  if ( LOWER ) 
   then I0 := K + 1;
  LM := N - KB;
  I1 := I0 + LM - 1;
  T :=SubC(Cmplx(0.0,0.0),Z[K-1]);
  I := ((LM) Mod (4)) + I0 - 1;
  if ( I <  I0 ) 
   then goto _350;
  for JJ:=I0 to I do
   begin
    Z[JJ-1] := AddC(Z[JJ-1],MulC(T,A[(JJ-1)+(K-1)*M]));
_340:
   end;
_350:
  I := I + 1;
  if ( I >  I1 ) 
   then goto _370;
  JJ := I;
  while ( JJ<=I1 ) do
   begin
    Z[JJ-1] := AddC(Z[JJ-1],MulC(T,A[(JJ-1)+(K-1)*M]));
    Z[JJ+0] := AddC(Z[JJ+0],MulC(T,A[(JJ+0)+(K-1)*M]));
    Z[JJ+1] := AddC(Z[JJ+1],MulC(T,A[(JJ+1)+(K-1)*M]));
    Z[JJ+2] := AddC(Z[JJ+2],MulC(T,A[(JJ+2)+(K-1)*M]));
_360:
    inc(JJ,4);
   end;
_370:
_380:
 end;
LL := 390;
goto _250;
_390:
LL := 400;
goto _110;
_400:
YNORM := S*YNORM;
if ( ANORM <>  0.0 ) 
 then RCOND := YNORM/ANORM;
_410:
end;

end.
